/************************************************************************************
*
*  Project Name:	Templates
*     File Name:	CMTool.h
*        Author:	Rob Neville (IIx)
*          Date:	May 17, 1989
*
*   Description:	Typedefs etc. for default CM Tool	
*
*************************************************************************************
*
*	Revision History:
*		5/17/89 - Original version by Rob Neville (IIx)
*		6/02/89 - Redone for Connection Tool
*		6/26/89 - Reved for CTB b2
*
************************************************************************************/

#include	<Resources.h>
#include	<ToolUtils.h>
#include	<Script.h>
#include	<CMIntf.h>
#include	<ConnectionTool.h>
#include	<CTBUtils.h>
#include	<CRMIntf.h>
#include	<Errors.h>

#define ByronItem		1
#define RobItem			2
#define BYRON_DUCK		1
#define ROB_GOD			2
#define TRUE_ID			3
#define FALSE_ID		4

#define	TNoErr			0
#define TRejected		cmRejected
#define TFailed			cmFailed
#define TTimeOut		cmTimeOut
#define TNotOpen		cmNotOpen
#define TNotClosed		cmNotClosed
#define TNoRequestPending	cmNoRequestPending
#define TNotSupported 	cmNotSupported
#define TNoTools		cmNoTools	
#define TGenericError 	cmGenericError

#define TInitMsg 		cmInitMsg
#define TDisposeMsg 	cmDisposeMsg
#define TSuspendMsg 	cmSuspendMsg
#define TResumeMsg 		cmResumeMsg 
#define TMenuMsg 		cmMenuMsg 
#define	TEventMsg		cmEventMsg
#define TActivateMsg 	cmActivateMsg
#define TDeactivateMsg 	cmDeactivateMsg
#define TIdleMsg 		cmIdleMsg
#define	TResetMsg 		cmResetMsg
#define TAbortMsg 		cmAbortMsg
#define TReadMsg 		cmReadMsg
#define TWriteMsg 		cmWriteMsg
#define TStatusMsg 		cmStatusMsg
#define TListenMsg 		cmListenMsg
#define TAcceptMsg 		cmAcceptMsg
#define TCloseMsg 		cmCloseMsg
#define TOpenMsg 		cmOpenMsg
#define TBreakMsg 		cmBreakMsg
#define	TIOKillMsg		cmIOKillMsg
#define	TEnvironsMsg 	cmEnvironsMsg

#define TValidateMsg	cmValidateMsg
#define TDefaultMsg		cmDefaultMsg

#define TSpreflightMsg	cmSpreflightMsg
#define TSsetupMsg		cmSsetupMsg
#define TSitemMsg		cmSitemMsg
#define TSfilterMsg		cmSfilterMsg
#define TScleanupMsg	cmScleanupMsg

#define TMgetMsg		cmMgetMsg
#define TMsetMsg		cmMsetMsg

#define T2English		cmL2English
#define T2Intl			cmL2Intl

typedef	ConnHandle	ToolHandle;

typedef struct Config
{
	Boolean	param1;
	Boolean	param2;
} Config, *ConfigPtr, **ConfigHdl;

typedef struct Private
{
	long	param;
} Private, *PrivatePtr, **PrivateHdl;